# AzuCraftyBoxes

AzuCraftyBoxes is a Valheim mod that allows players to access and use resources from nearby containers when crafting and building, based on a configurable range and item restrictions.

## Features

- Automatically use resources from nearby containers within a configurable range when crafting or building
- Restrict specific items from being pulled out of containers by defining rules in the configuration file in the `BepInEx/config` folder called `Azumatt.AzuCraftyBoxes.yml`
- Toggle the mod on/off in-game using a configurable hotkey
- Flashing UI text to indicate when resources are being pulled from nearby containers


**Version checks with itself. If installed on the server, it will kick clients who do not have it installed.**

**This mod uses ServerSync, if installed on the server and all clients, it will sync all configs with [Synced with Server] tags to client**

**This mod uses a file watcher. If the configuration file is not changed with BepInEx Configuration manager, but changed in the file directly on the server, upon file save, it will sync the changes to all clients.**


<details>
<summary><b>Configuration Options</b></summary>

### General

> Configuration File Name: `Azumatt.AzuCraftyBoxes.cfg`

`1 - General`

Lock Configuration [Synced with Server]
* If on, the configuration is locked and can be changed by server admins only.
    * Default Value: On

Mod Enabled [Synced with Server]
* If off, everything in the mod will not run. This is useful if you want to disable the mod without uninstalling it.
    * Default Value: On

`2 - CraftyBoxes`

Container Range [Synced with Server]
* The maximum range from which to pull items from.
    * Default Value: 20

ResourceCostString [Not Synced with Server]
* String used to show required and available resources. {0} is replaced by how much is available, and {1} is replaced by how much is required. Set to nothing to leave it as default.
    * Default Value: {0}/{1}

FlashColor [Not Synced with Server]
* Resource amounts will flash to this colour when coming from containers
    * Default Value: FFEB04FF

UnFlashColor [Not Synced with Server]
* Resource amounts will flash from this colour when coming from containers (set both colors to the same color for no flashing)
    * Default Value: FFFFFFFF

PulledMessage [Not Synced with Server]
* Message to show after pulling items to player inventory
    * Default Value: Pulled items to inventory

`3 - Keys`

PullItemsKey [Not Synced with Server]
* Holding down this key while crafting or building will pull resources into your inventory instead of building. Use https://docs.unity3d.com/Manual/ConventionalGameInput.html
    * Default Value: LeftControl

</details>

<details>
<summary><b>Installation Instructions</b></summary>

### Manual Installation

`Note: (Manual installation is likely how you have to do this on a server, make sure BepInEx is installed on the server correctly)`

1. **Download the latest release of BepInEx.**
2. **Extract the contents of the zip file to your game's root folder.**
3. **Download the latest release of AzuCraftyBoxes from Thunderstore.io.**
4. **Extract the contents of the zip file to the `BepInEx/plugins` folder.**
5. **Launch the game.**

### Installation through r2modman or Thunderstore Mod Manager

1. **Install [r2modman](https://valheim.thunderstore.io/package/ebkr/r2modman/) or [Thunderstore Mod Manager](https://www.overwolf.com/app/Thunderstore-Thunderstore_Mod_Manager).**

   > For r2modman, you can also install it through the Thunderstore site.
   ![](https://i.imgur.com/s4X4rEs.png "r2modman Download")

   > For Thunderstore Mod Manager, you can also install it through the Overwolf app store
   ![](https://i.imgur.com/HQLZFp4.png "Thunderstore Mod Manager Download")
2. **Open the Mod Manager and search for "AzuCraftyBoxes" under the Online tab. `Note: You can also search for "Azumatt" to find all my mods.`**
   The image below shows VikingShip as an example, but it was easier to reuse the image. Type AzuCraftyBoxes.

![](https://i.imgur.com/5CR5XKu.png)
3. **Click the Download button to install the mod.**
4. **Launch the game.**

</details>


<details><summary><b>Example YAML</b></summary>

```yml
# Below you can find example groups. Groups are used to exclude or includeOverride quickly. They are reusable lists! 
#Please note that some of these groups/container limitations are kinda pointless but are here for example.
# Make sure to follow the format of the example below. If you have any questions, please ask in my discord.

# Full vanilla prefab name list: https://valheim-modding.github.io/Jotunn/data/prefabs/prefab-list.html
# Item prefab name list: https://valheim-modding.github.io/Jotunn/data/objects/item-list.html

groups:
Swords: # Group name
  - SwordBlackmetal # Item prefab name, note that this is case sensitive and must be the prefab name
  - SwordBronze
  - SwordIron
  - SwordMistwalker
  - THSwordKrom
  - SwordCheat
  - SwordIronFire
  - SwordSilver
Armor:
  - ArmorBronzeChest
  - ArmorBronzeLegs
  - ArmorCarapaceChest
  - ArmorCarapaceLegs
  - ArmorFenringChest
  - ArmorFenringLegs
  - ArmorIronChest
  - ArmorIronLegs
  - ArmorLeatherChest
  - ArmorLeatherLegs
  - ArmorMageChest
  - ArmorMageLegs
  - ArmorPaddedCuirass
  - ArmorPaddedGreaves
  - ArmorRagsChest
  - ArmorRagsLegs
  - ArmorRootChest
  - ArmorRootLegs
  - ArmorTrollLeatherChest
  - ArmorTrollLeatherLegs
  - ArmorWolfChest
  - ArmorWolfLegs
Food:
  - BarleyWine
  - BlackSoup
  - BloodPudding
  - Blueberries
  - BoarJerky
  - Bread
  - Carrot
  - CarrotSoup
  - Cloudberry
  - CookedBugMeat
  - CookedChickenMeat
  - CookedDeerMeat
  - CookedEgg
  - CookedHareMeat
  - CookedLoxMeat
  - CookedMeat
  - CookedWolfMeat
  - DeerStew
  - Eyescream
  - FishAndBread
  - FishCooked
  - FishWraps
  - HealthUpgrade_Bonemass
  - HealthUpgrade_GDKing
  - Honey
  - HoneyGlazedChicken
  - LoxPie
  - MagicallyStuffedShroom
  - MeadEitrMinor
  - MeadFrostResist
  - MeadHealthMajor
  - MeadHealthMedium
  - MeadHealthMinor
  - MeadPoisonResist
  - MeadStaminaLingering
  - MeadStaminaMedium
  - MeadStaminaMinor
  - MeadTasty
  - MeatPlatter
  - MinceMeatSauce
  - MisthareSupreme
  - Mushroom
  - MushroomBlue
  - MushroomJotunPuffs
  - MushroomMagecap
  - MushroomOmelette
  - MushroomYellow
  - NeckTailGrilled
  - Onion
  - OnionSoup
  - Pukeberries
  - QueensJam
  - Raspberry
  - RottenMeat
  - RoyalJelly
  - Salad
  - Sausages
  - SeekerAspic
  - SerpentMeatCooked
  - SerpentStew
  - ShocklateSmoothie
  - StaminaUpgrade_Greydwarf
  - StaminaUpgrade_Troll
  - StaminaUpgrade_Wraith
  - TurnipStew
  - WolfJerky
  - WolfMeatSkewer
  - YggdrasilPorridge
Arrows:
  - ArrowBronze
  - ArrowCarapace
  - ArrowFire
  - ArrowFlint
  - ArrowFrost
  - ArrowIron
  - ArrowNeedle
  - ArrowObsidian
  - ArrowPoison
  - ArrowSilver
  - ArrowWood
  - draugr_arrow
Ores:
  - CopperOre
  - IronOre
  - SilverOre
  - TinOre
  - FlametalOre
Scraps:
  - BlackMetalScrap
  - BronzeScrap
  - CopperScrap
  - IronScrap
  - LeatherScraps
Tier 2 Items:
  - Bronze
  - PickaxeBronze
  - ArmorBronzeChest
  - ArmorBrozeLeggings
Bows:
  - Bow
  - BowDraugrFang
  - BowFineWood
  - BowHuntsman
  - BowSpineSnap
  - CrossbowArbalest


# By default, if you don't specify a container below, it will be considered as you want to allow pulling all objects for pulling from it.
# If you are having issues with a container, please make sure you have the full prefab name of the container. Additionally, make sure you have exclude or includeOverride set up correctly.
# Worst case you can define a container like this. This will allow everything to be pulled from the container.
# rk_barrel:
#  includeOverride:
#    -

piece_chest:
exclude: # Exclude these items from being able to be pulled from the container
  - Food # Exclude Group
  - PickaxeBronze # Allow prefab names as well, in this case we will use something that isn't a food

piece_chest_wood:
exclude:
  - Swords # Exclude all in group
  - Tier 2 Items # Exclude all in group
  - Bows # Exclude all in group
includeOverride: # If the item is in the groups above, say, you were using a predefined group but want to override just one item to be ignored and allow pulling it
  - BowFineWood
  - Wood

piece_chest_private:
exclude:
  - Swords
  - Tier 2 Items
  - Bows
includeOverride:
  - BowHuntsman

piece_chest_blackmetal:
exclude:
  - Swords # Exclude all in group
  - Tier 2 Items # Exclude all in group
  - Bows # Exclude all in group
includeOverride: # If the item is in the groups above, say, you were using a predefined group but want to override just one item to be ignored and allow pulling it
  - BowFineWood
  - Wood

rk_cabinet:
exclude:
  - Food

rk_cabinet2:
exclude:
  - Food

rk_barrel:
exclude:
  - Armor
  - Swords

rk_barrel2:
exclude:
  - Armor
  - Swords

rk_crate:
exclude:
  - Armor
  - Swords

rk_crate2:
exclude:
  - Armor
  - Swords
```


</details>

**Feel free to reach out to me on discord if you need manual download assistance.**


# Author Information

### Azumatt

`DISCORD:` Azumatt#2625

`STEAM:` https://steamcommunity.com/id/azumatt/

For Questions or Comments, find me in the Odin Plus Team Discord or in mine:

[![https://i.imgur.com/XXP6HCU.png](https://i.imgur.com/XXP6HCU.png)](https://discord.gg/Pb6bVMnFb2)
<a href="https://discord.gg/pdHgy6Bsng"><img src="https://i.imgur.com/Xlcbmm9.png" href="https://discord.gg/pdHgy6Bsng" width="175" height="175"></a>